<?php
// ╔═══════════════════════════════════════════════════════════════════════╗
// ║ Card                                                                  ║
// ║                                                                       ║
// ║ @param  string       $class       Extra classes for card element      ║
// ║ @param  string|date  $thumb       Either an image url, or date object ║
// ║ @param  string       $heading                                         ║
// ║ @param  assoc array  $subheadings Items below header with gen classes ║
// ║ @param  string       $content                                         ║
// ║                                                                       ║
// ║ @param  bool         $detail      If a card is a detail page          ║
// ║                                                                       ║
// ╚═══════════════════════════════════════════════════════════════════════╝
?>
<div class="card <?php
	if (!empty($thumb))  echo 'card--has-thumb ';
	if (!empty($detail)) echo 'card--detail ';
	if (!empty($class))  echo $class;
?>">

	<?php
		if (!empty($thumb)):
			echo '<div class="card__thumb">';

			if (is_string($thumb)): // thumb image
				$thumbHtml = $this->Html->image($thumb, [
					'alt' => '',
					'width' => 180,
					'height' => 180,
					'class' => 'card__thumb__image',
				]);
			else: // thumb date
				$thumbHtml = '<div class="card__thumb__date">' . Date('M Y', $thumb) . '</div>';
			endif;

			if (!empty($url)):
				echo $this->Html->link(
					$thumbHtml,
					$url,
					['escape' => false]
				);
			else:
				echo $thumbHtml;
			endif;

			echo '</div>';
		endif;
	?>
	<div class="card__content">
		<?php if (!empty($heading)): ?>
			<div class="card__title">
				<?php
					if (!empty($url)):
						echo $this->Html->link(
							$heading,
							$url
						);
					else:
						echo $heading;
					endif;
				?>
			</div>
		<?php endif; ?>

		<?php if (!empty($subheadings)): ?>
			<div class="card__subheadings">
				<?php
					/**
					 * Subheading elements
					 * Create lovely little spans with predictable classnames, e.g.
					 * .card__subheading.card__subheading--date
					 **/
					foreach ($subheadings as $key => $val):
						echo '<span class="card__subheading card__subheading--' . InflectorExt::snake($key) . '">';
							switch ($key):
								case "date":
									echo Date("d/m/Y", $val);
									break;
								default;
									echo $val;
									break;
							endswitch;
						echo '</span>';
					endforeach;
				?>
			</div>
		<?php endif; ?>

		<?php if (!empty($content)): ?>
			<?= $content; ?>
		<?php endif; ?>
	</div>
</div>

<div class="spacer"></div>
